'use strict';

var camelCase = require('lodash/camelCase');
var lodash = require('lodash');

function _interopDefaultCompat (e) { return e && typeof e === 'object' && 'default' in e ? e : { default: e }; }

var camelCase__default = /*#__PURE__*/_interopDefaultCompat(camelCase);

const generateAnnotationFactName = (annotation) => camelCase__default.default(`hasAnnotation-${annotation}`);
const entityHasAnnotation = (entity, annotation) => Boolean(lodash.get(entity, ["metadata", "annotations", annotation]));
const isTtl = (lifecycle) => {
  return !!lifecycle.timeToLive;
};
const isMaxItems = (lifecycle) => {
  return !!lifecycle.maxItems;
};

exports.entityHasAnnotation = entityHasAnnotation;
exports.generateAnnotationFactName = generateAnnotationFactName;
exports.isMaxItems = isMaxItems;
exports.isTtl = isTtl;
//# sourceMappingURL=utils.cjs.js.map
