'use strict';

var TechInsightsDatabase = require('./TechInsightsDatabase.cjs.js');
var backendPluginApi = require('@backstage/backend-plugin-api');

const migrationsDir = backendPluginApi.resolvePackagePath(
  "@backstage-community/plugin-tech-insights-backend",
  "migrations"
);
const initializePersistenceContext = async (database, options) => {
  const client = await database.getClient();
  if (!database.migrations?.skip) {
    await client.migrate.latest({
      directory: migrationsDir
    });
  }
  return {
    techInsightsStore: new TechInsightsDatabase.TechInsightsDatabase(client, options.logger)
  };
};

exports.initializePersistenceContext = initializePersistenceContext;
//# sourceMappingURL=persistenceContext.cjs.js.map
